"""Autogenerated API schema"""
from argus_api import session


get_functions = {'tags': ['currentuser/v1'], 'summary': "List the current user's permission functions regardless of customer (PUBLIC)", 'description': '', 'operationId': 'getFunctions', 'produces': ['application/json'], 'parameters': [{'name': 'offset', 'in': 'query', 'description': 'Skip a number of functions', 'required': False, 'type': 'int', 'default': 0, 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned functions', 'required': False, 'type': 'int', 'default': 25, 'minimum': 0}, {'name': 'onlyRoles', 'in': 'query', 'description': 'Only return functions marked as roles', 'required': False, 'type': 'bool'}, {'name': 'requirePermission', 'in': 'query', 'description': 'Only return functions which current user has access to', 'required': False, 'type': 'bool', 'default': True}, {'name': 'maxSecurityLevel', 'in': 'query', 'description': 'Only return functions which are available with this security level', 'required': False, 'type': 'str', 'default': 'current', 'enum': ['current', 'external', 'standard', 'administrative']}, {'name': 'keywords', 'in': 'query', 'description': 'Filter functions by keywords on name and description', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the function.'}}, 'description': 'SPI FunctionInfo'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Forbidden permission'}, '412': {'description': 'Invalid request'}}}