"""Autogenerated API schema"""
from argus_api import session


search_records_simplified = {'tags': ['pdns/v3'], 'summary': 'Search against PassiveDNS and return matching records (PUBLIC)', 'description': 'Search against PassiveDNS with criteria and return matching records. If user exceeds current resource limits, this operation may return status code 402. If that happens, the metaData key millisUntilResourcesAvailable gives a hint as to how long the client needs to wait before attempting again.', 'operationId': 'searchRecordsSimplified', 'produces': ['application/json'], 'parameters': [{'name': 'query', 'in': 'path', 'description': 'Search by query', 'required': True, 'type': 'str'}, {'name': 'aggregate', 'in': 'query', 'description': 'Whether aggregate records', 'required': False, 'type': 'bool', 'default': True}, {'name': 'includeAnonymous', 'in': 'query', 'description': 'Whether include anonymous records', 'required': False, 'type': 'bool', 'default': True}, {'name': 'rrClass', 'in': 'query', 'description': 'Search by recordClass (rrclass)', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'rrType', 'in': 'query', 'description': 'Search by type (rrtype)', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'customerID', 'in': 'query', 'description': 'Search by customerID', 'required': False, 'type': 'list', 'items': {'type': 'int'}, 'collectionFormat': 'multi'}, {'name': 'tlp', 'in': 'query', 'description': 'Search by TLP', 'required': False, 'type': 'list', 'items': {'type': 'str', 'enum': ['white', 'green', 'amber', 'red']}, 'collectionFormat': 'multi'}, {'name': 'offset', 'in': 'query', 'description': 'Skip a number of records', 'required': False, 'type': 'int', 'default': 0, 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Max number of records to be returned', 'required': False, 'type': 'int', 'default': 25, 'minimum': 0}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'createdTimestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'times': {'type': 'int'}, 'tlp': {'type': 'str', 'enum': ['white', 'green', 'amber', 'red']}, 'query': {'type': 'string'}, 'answer': {'type': 'string'}, 'minTtl': {'type': 'int'}, 'maxTtl': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'lastSeenTimestamp': {'type': 'int', 'readOnly': True}, 'firstSeenTimestamp': {'type': 'int', 'readOnly': True}, 'rrclass': {'type': 'str', 'readOnly': True, 'enum': ['in']}, 'rrtype': {'type': 'str', 'readOnly': True, 'enum': ['a', 'aaaa', 'cname', 'dname', 'mx', 'naptr', 'ns', 'ptr', 'rp', 'soa', 'srv', 'txt']}}}}}}}, '401': {'description': 'Authentication failed'}, '402': {'description': 'Resource limit exceeded'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}